Rust Search

Find the best content on Rust, curated by the community; a search engine for Rustaceans.
github.com
## Summary Allow a re-export of a function as entry point `main`. ## Motivation Functions and re-exports of functions usually behave the same way, but they do not for the program entry point `main`. This RFC aims to fix this inconsistency....
RFC 1260 RFC 2015-08-19 ~1 min read
github.com
## Summary Implement `.drain(range)` and `.drain()` respectively as appropriate on collections. ## Motivation The `drain` methods and their draining iterators serve to mass remove elements from a collection, receiving them by value in an it...
RFC 1257 RFC 2015-08-14 ~3 min read
github.com
NA
## Summary Taking a reference into a struct marked `repr(packed)` should become `unsafe`, because it can lead to undefined behaviour. `repr(packed)` structs need to be banned from storing `Drop` types for this reason. ## Motivation Issue [#...
RFC 1240 RFC 2015-08-06 ~10 min read
github.com
## Summary Revise the Drop Check (`dropck`) part of Rust's static analyses in two ways. In the context of this RFC, these revisions are respectively named `cannot-assume-parametricity` and `unguarded-escape-hatch`. 1. `cannot-assume-paramet...
RFC 1238 RFC 2015-08-05 ~15 min read
github.com
## Summary Document and expand the open options. ## Motivation The options that can be passed to the os when opening a file vary between systems. And even if the options seem the same or similar, there may be unexpected corner cases. This R...
RFC 1252 RFC 2015-08-04 ~22 min read
github.com
## Summary Enable the compiler to cache incremental workproducts. ## Motivation The goal of incremental compilation is, naturally, to improve build times when making small edits. Any reader who has never felt the need for such a feature is...
RFC 1298 RFC 2015-08-04 ~23 min read
github.com
## Summary [summary]: #summary Copy most of the static `ptr::` functions to methods on unsafe pointers themselves. Also add a few conveniences for `ptr.offset` with unsigned integers. ```rust // So this: ptr::read(self.ptr.offset(idx as isi...
RFC 1966 RFC 2015-08-01 ~8 min read
github.com
## Summary If the constant evaluator encounters erroneous code during the evaluation of an expression that is not part of a true constant evaluation context a warning must be emitted and the expression needs to be translated normally. ## De...
RFC 1229 RFC 2015-07-30 ~2 min read
github.com
## Summary This RFC proposes a policy around the crates under the rust-lang github organization that are not part of the Rust distribution (compiler or standard library). At a high level, it proposes that these crates be: - Governed similar...
RFC 1242 RFC 2015-07-29 ~8 min read
github.com
## This RFC was previously approved, but later **withdrawn** For details see the [summary comment]. [summary comment]: https://github.com/rust-lang/rust/issues/27779#issuecomment-378416911 ## Summary Rather than trying to find a clever synt...
RFC 1228 RFC 2015-07-28 ~6 min read
github.com
## Summary Move `std::thread::catch_panic` to `std::panic::recover` after replacing the `Send + 'static` bounds on the closure parameter with a new `PanicSafe` marker trait. ## Motivation In today's stable Rust it's not possible to catch a...
RFC 1236 RFC 2015-07-24 ~17 min read
github.com
## Summary A Cargo crate's dependencies are associated with constraints that specify the set of versions of the dependency with which the crate is compatible. These constraints range from accepting exactly one version (`=1.2.3`), to accepti...
RFC 1241 RFC 2015-07-23 ~5 min read
github.com
## Summary Promote `!` to be a full-fledged type equivalent to an `enum` with no variants. ## Motivation To understand the motivation for this it's necessary to understand the concept of empty types. An empty type is a type with no inhabita...
RFC 1216 RFC 2015-07-19 ~13 min read
github.com
## Summary Type system changes to address the outlives relation with respect to projections, and to better enforce that all types are well-formed (meaning that they respect their declared bounds). The current implementation can be both unso...
RFC 1214 RFC 2015-07-17 ~34 min read
github.com
Mir
## Summary Introduce a "mid-level IR" (MIR) into the compiler. The MIR desugars most of Rust's surface representation, leaving a simpler form that is well-suited to type-checking and translation. ## Motivation The current compiler uses a si...
RFC 1211 RFC 2015-07-14 ~27 min read
github.com
## Summary Add a new subcommand to Cargo, `install`, which will install `[[bin]]`-based packages onto the local system in a Cargo-specific directory. ## Motivation There has [almost always been a desire][cargo-37] to be able to install Carg...
RFC 1200 RFC 2015-07-10 ~8 min read
github.com
## This RFC was previously approved, but later **withdrawn** In short this RFC was superseded by RFC 2972. For details see the [summary comment]. [summary comment]: https://github.com/rust-lang/rust/issues/32408#issuecomment-1016931986 ## S...
RFC 1201 RFC 2015-07-10 ~5 min read
github.com
## Summary Change all functions dealing with reading "lines" to treat both '\n' and '\r\n' as a valid line-ending. ## Motivation The current behavior of these functions is to treat only '\n' as line-ending. This is surprising for programmer...
RFC 1212 RFC 2015-07-10 ~2 min read
github.com
## Summary Add element-recovery methods to the set types in `std`. ## Motivation Sets are sometimes used as a cache keyed on a certain property of a type, but programs may need to access the type's other properties for efficiency or functio...
RFC 1194 RFC 2015-07-08 ~2 min read
github.com
## Summary Allow a `x...y` expression to create an inclusive range. ## Motivation There are several use-cases for inclusive ranges, that semantically include both end-points. For example, iterating from `0_u8` up to and including some numbe...
RFC 1192 RFC 2015-07-07 ~5 min read
"*relatively speaking*, my rust programs are like Leonardo DiCaprio in the Revenant, killing grizzly bears with their bare hands, dying and being froze..."

Search tips

Type anything to search across articles, videos (including conference talks), podcasts, research, crates, and Rust API documentation. These operators give you finer control — click an example to try it.

Find pages containing all your words. Pages where the words appear together rank higher.
Quote part of your query to keep those words together as an exact phrase within a larger search.
Wrap the whole query in quotes for a verbatim search that matches text exactly, punctuation and all — perfect for Rust syntax. Needs at least 3 characters.
Put ! first to open the top result immediately. Quote the whole query for a literal leading bang, as in '!Send'. Bangs elsewhere, such as println!, stay literal. Browser and launcher shortcuts can invoke this directly. See search integrations.
Limit results to a single site. Works on its own () too. One site: per search.

Use the tabs and filters above the results to narrow by content type, publication year, and sort order.